package com.xet.user.controller;

import com.xet.domain.user.dto.LoginDto;
import com.xet.domain.user.dto.WxLoginDto;
import com.xet.user.service.UserService;
import com.xet.util.jie.ResultVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Date 2025/5/5 20:03
 * @Author neko
 **/
@RestController
@RequestMapping("/users")
public class LoginController {
    @Autowired
    UserService userService;

    /*
     * 手机号 密码/验证码 登录
     */
    @RequestMapping("phone_login")
    public ResultVo phoneLogin(@RequestBody LoginDto loginDto){
        return userService.phoneLogin(loginDto);
    }

    /*
     * 微信一键登录
     */
    @RequestMapping("wx_login")
    public ResultVo wxLogin(@RequestBody WxLoginDto wxLoginDto){
        return userService.wxLogin(wxLoginDto);
    }


    /*
    * 获取验证码
    */
    @RequestMapping("yan")
    public ResultVo yan(String phone){
        return userService.yan(phone);
    }

}
