package com.xet.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xet.domain.user.dto.LoginDto;
import com.xet.domain.user.dto.WxLoginDto;
import com.xet.domain.user.pojo.Users;
import com.xet.user.mapper.UserMapper;
import com.xet.user.service.UserService;
import com.xet.util.HttpUtils;
import com.xet.util.jie.ApiServiceExceptionEnum;
import com.xet.util.jie.ResultVo;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.HttpResponse;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;

import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

/**
 * @Date 2025/5/5 20:04
 * @Author neko
 **/
@Slf4j
@Service
public class UserServiceImpl implements UserService {
    @Autowired
    UserMapper userMapper;

    @Override
    public ResultVo phoneLogin(LoginDto loginDto) {
        if(StringUtils.isEmpty(loginDto.getPhone())){
            return ResultVo.error(ApiServiceExceptionEnum.PHONE_NOTNULL);
        }
        if(loginDto.getPassword()!=null){
            log.info("手机号密码登录",loginDto.getPhone());
            QueryWrapper<Users> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().eq(Users::getPhone,loginDto.getPhone());
            Users u = userMapper.selectOne(queryWrapper);
            String salt = u.getSalt();
            String md5Pwd = DigestUtils.md5DigestAsHex((salt+loginDto.getPassword()).getBytes(StandardCharsets.UTF_8));
            if(!loginDto.getPhone().matches("^1[3-9]\\d{9}$")){
                return ResultVo.error(ApiServiceExceptionEnum.PHONE_ERROR);
            }
            if(!md5Pwd.equals(u.getPassword())){
                return ResultVo.error(ApiServiceExceptionEnum.PASSWORD_ERROR);
            }

            String token = "";
            Map<String, Object> map = new HashMap<>();
            map.put("token",token);
            return ResultVo.success();
        }else{
            log.info("手机号验证码 登录/注册"+loginDto.getPhone());
            if(!loginDto.getPhone().matches("^1[3-9]\\d{9}$")){
                return ResultVo.error(ApiServiceExceptionEnum.PHONE_ERROR);
            }

            QueryWrapper<Users> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().eq(Users::getPhone,loginDto.getPhone());
            Users u = userMapper.selectOne(queryWrapper);
            if(u==null){
                Users users = new Users();
                users.setPhone(loginDto.getPhone());
                users.setNickname("用户"+loginDto.getPhone());
                userMapper.insert(users);
                log.info("新用户注册成功"+users.getNickname());
            }

            String token = "";
            Map<String, Object> map = new HashMap<>();
            map.put("token",token);
            return ResultVo.success();
        }

    }

    @Override
    public ResultVo yan(String phone) {
        String host = "https://gyytz.market.alicloudapi.com";
        String path = "/sms/smsSend";
        String method = "POST";
        String appcode = "8e678d7c72f14e9193e29747f9d73a6d";
        Map<String, String> headers = new HashMap<String, String>();
        //最后在header中的格式(中间是英文空格)为Authorization:APPCODE 83359fd73fe94948385f570e3c139105
        headers.put("Authorization", "APPCODE " + appcode);
//        System.err.println(phone);

        //生成一个随机6位的验证码
        Random random = new Random();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < 6; i++) {
            int digit = random.nextInt(10);
            sb.append(digit);
        }
        String sixDigitNumber = sb.toString();

        Map<String, String> querys = new HashMap<String, String>();
        querys.put("mobile", phone);
        querys.put("param", "**code**:"+sixDigitNumber+",**minute**:6");

        querys.put("smsSignId", "2e65b1bb3d054466b82f0c9d125465e2");
        querys.put("templateId", "908e94ccf08b4476ba6c876d13f084ad");
        Map<String, String> bodys = new HashMap<String, String>();


        try {
            HttpResponse response = HttpUtils.doPost(host, path, method, headers, querys, bodys);
            System.out.println(response.toString());
            //获取response的body
            //System.out.println(EntityUtils.toString(response.getEntity()));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ResultVo.success("短信发送成功");
    }

    @Override
    public ResultVo wxLogin(WxLoginDto wxLoginDto) {

        return null;
    }


}
